"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useFetch = useFetch;

var _usePromise = require("./usePromise");

function useFetch(path, options) {
  var defaultFormatter = function defaultFormatter(response) {
    return response.json();
  };

  var fetchInstance = function fetchInstance(path, options) {
    return fetch(path, options).then(options && options.formatter || defaultFormatter);
  };

  return (0, _usePromise.usePromise)(fetchInstance, path, options);
}